# vault_tools

## Table of Contents

1. [Description](#description)
1. [Setup - The basics of getting started with vault_tools](#setup)
    * [Beginning with vault_tools](#beginning-with-vault_tools)
1. [Usage - Configuration options and additional functionality](#usage)
1. [Limitations - OS compatibility, etc.](#limitations)
1. [Development - Guide for contributing to the module](#development)

## Description

Provides usefull utils for vault. Such as:
  * sync vault secrets with files

Developers suggest to render manifests of this module on serverside, so it's easy to manage credentials for vault. Simply add ENVs to `/etc/puppetlabs/puppetserver/conf.d/puppetserver.conf` as described [here](https://www.puppet.com/docs/puppet/8/server/config_file_puppetserver.html#settings), in docs.

## Setup

### Beginning with vault_tools

To install this module you can simply follow default instructions:

Add following line into your `Puppetfile`:
```Puppetfile
mod 'none0nfg-vault_tools', '<VERSION>'
```
or manually
```Puppetfile
puppet module install none0nfg-vault_tools --version <VERSION>
```

## Usage

Just sync some secret from vault to filesystem

```Puppet
vault_tools::vault_file_sync { 'secret/data/certs':
  dest => '/etc/ssl',
  file_specs => {
    owner => 'nginx',
    group => 'nginx',
    mode  => '0664'
  },
  vault_client => {approle_path_segment => 'v1/auth/approle/'},
}
```

Current example will produce each key of `'secret/data/certs'` as file, using key as a filename, and content will be the values of that keys

Remeber that `approle_path_segment` shoud ends with `/` or it will raise a error.

## Limitations

No specific limitations

## Development

There is no way to contribute for now.
