# Reference

<!-- DO NOT EDIT: This document was generated by Puppet Strings -->

## Table of Contents

### Defined types

* [`vault_tools::vault_file_sync`](#vault_tools--vault_file_sync): This defined_type provides way to sync vault's secret content with files in filesystem.

## Defined types

### <a name="vault_tools--vault_file_sync"></a>`vault_tools::vault_file_sync`

A description of what this defined type does

#### Examples

##### 

```puppet
vault_tools::vault_file_sync { 'secret/data/certs':
  dest => '/tmp',
  file_specs => {
    owner => 'nginx',
    group => 'nginx',
  },
  keys_to_place => ["cert.pem","fullchain.pem","privkey.pem"],
  per_file_specs => {
    'cert.pem' => {
      owner => 'root',
      group => 'root',
    }
  },
  vault_client => {approle_path_segment => 'v1/auth/approle/'},
}
```

#### Parameters

The following parameters are available in the `vault_tools::vault_file_sync` defined type:

* [`vault_path`](#-vault_tools--vault_file_sync--vault_path)
* [`vault_client`](#-vault_tools--vault_file_sync--vault_client)
* [`dest`](#-vault_tools--vault_file_sync--dest)
* [`keys_to_place`](#-vault_tools--vault_file_sync--keys_to_place)
* [`per_file_specs`](#-vault_tools--vault_file_sync--per_file_specs)
* [`file_specs`](#-vault_tools--vault_file_sync--file_specs)

##### <a name="-vault_tools--vault_file_sync--vault_path"></a>`vault_path`

Data type: `String`

Defines path to get secret from

Default value: `$title`

##### <a name="-vault_tools--vault_file_sync--vault_client"></a>`vault_client`

Data type: `Hash`

Hash defines vault connection parametes, check available parameters in (vault-lookup)[https://forge.puppet.com/modules/puppet/vault_lookup/readme] module

Default value: `{}`

##### <a name="-vault_tools--vault_file_sync--dest"></a>`dest`

Data type: `String`

Defines path to place files into

Default value: `undef`

##### <a name="-vault_tools--vault_file_sync--keys_to_place"></a>`keys_to_place`

Data type: `Optional[Array[String]]`

Define keys from vault's secret to place in $dest directory

Default value: `undef`

##### <a name="-vault_tools--vault_file_sync--per_file_specs"></a>`per_file_specs`

Data type: `Hash`

Define per file config in format of `file` resource type, e.g.
```
file_specs => {
  '<VAULT_FILE_KEY>'   => {
    <any param of `file` type> => ...
  },
  '<VAULT_FILE_KEY_2>' => {
    <any param of `file` type> => ...
  }
}
```

Default value: `{}`

##### <a name="-vault_tools--vault_file_sync--file_specs"></a>`file_specs`

Data type: `Hash`

Define linux permissions for each file created by this resource type

Default value:

```puppet
{
    owner => 'root',
    group => 'root',
    mode  => '0644',
  }
```

